﻿using Newtonsoft.Json;
using PSO2SERVER.Models;
using PSO2SERVER.Protocol.Packets;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PSO2SERVER.Json
{
    public class QuestData
    {
        [JsonProperty("definition")]
        public QuestDefiniton QuestDefiniton { get; set; }
        [JsonProperty("difficulties")]
        public QuestDifficulty Difficulty { get; set; }
        [JsonProperty("map")]
        public MapData Mapdata { get; set; }
        [JsonProperty("enemies")]
        public List<EnemyData> Enemies { get; set; }
        [JsonProperty("immediate_move")]
        public bool ImmediateMove {  get; set; }

        public QuestData()
        {
            QuestDefiniton = new QuestDefiniton();
            Difficulty = new QuestDifficulty();
            Mapdata = new MapData();
            Enemies = new List<EnemyData>();
            ImmediateMove = false;
        }
    }

    public class EnemyData
    {
        [JsonProperty("difficulty")]
        public ushort Difficulty { get; set; }
        [JsonProperty("mapid")]
        public uint mapid { get; set; }
        [JsonProperty("data")]
        public EnemySpawnPacket data { get; set; }
        [JsonProperty("lua_data")]
        public string lua_data { get; set; }
    }
}
